# Performance Test Cases

Store performance for:

* Hardware
* OS and Compiler (compile once, run on several computers)

## OS and Compiler Combinations

* Ubuntu 14.04.5 LTS (03/2018)
    gcc version 4.8.4 (Ubuntu 4.8.4-2ubuntu1~14.04.4)
* Ubuntu 16.04.4 LTS (03/2018)
    gcc version 5.4.0 20160609 (Ubuntu 5.4.0-6ubuntu1~16.04.9)
* Ubuntu 17.10.1 (03/2018)
    gcc version 7.2.0 (Ubuntu 7.2.0-8ubuntu3.2)
    
## Solver Variants

All compiler with *release* build type.

* Single-Core (no OpenMP)
* OpenMP Parallelization

## Case 1 : Corner (direct solver)

Simple L-shape wall corner:

* *LES Solver*: Band
* *Execution Variants*: Single-Core, 4-Core

Results:

1404_omp4	1.131 h
1604_omp4	0.932 h
1710_omp4	0.916 h
win7_vc14_omp4	0.987 h
win7_vc17_omp4	1.039 h

1404_serial	1.875 h
1604_serial	1.635 h
1710_serial	1.691 h
win7_vc14_serial	1.728 h

## Case 2 : Corner (iterative solver)

1404_omp4	
1604_omp4	7.298 min
1710_omp4	
win7_vc14_omp4
win7_vc17_omp4