# Performance Test Concept

## Verzeichnis mit Testfällen

Jeder Testfall bereits fertig konfiguriert:

- Gitter
- Bilanzgleichungen
- Simulationszeitraum
- Solveroptionen

## Ausführungsoptionen

- Sequentiell
- 2 Kerne
- 4 Kerne

Konfigurierbar als Argumente für das Python-Skript

## Ablauf des Tests


```python
# Alle Tests unterhalb von 'baseDir' ausführen,
# dabei 'threadCount' Prozesse verwenden und
# die Ergebnisse unterhalb von tmpRootDir generieren.
# Jeder Testlauf wird 'bestOfN' durchgeführt, wobei das
# Ergebnis des besten Tests gespeichert wird.
processTests(baseDir, threadCount, tmpRootDir, bestOfN)
```

Verzeichnispfadbeispiel:

    /home/ghorwin/PerformanceTests/2D/ecke_large_grid.d6p

```python
processTests("/home/ghorwin/PerformanceTests", 2, "/var/tmp/PerformanceTests", 3)
```
generiert die Verzeichnisse

    /var/tmp/PerformanceTests/2D/ecke_large_grid-02-1
    /var/tmp/PerformanceTests/2D/ecke_large_grid-02-2
    /var/tmp/PerformanceTests/2D/ecke_large_grid-02-3

und generiert die Zusammenfassung der Statistik in

    /home/ghorwin/PerformanceTests/results.txt

### Break and Continue

Bei langen Tests kann es passieren, dass das Script mal gestoppt werden muss.

Daher muss bei jedem Simulationslauf getestet werden, ob das Zielverzeichnis schon existiert und gültige Statistiken erfasst sind. Dann wird der Lauf einfach übersprungen.


## Umsetzung

```python
processTests(baseDir, threadCount, tmpRootDir, bestOfN)
```

geht rekursiv durch alle Verzeichnisse und sucht nach d6p-Dateien (konfigurierbar?). Dann wird die Funktion `best_of_N()` aufgerufen, welche die individuellen Simulationen durchführen. Die von `best_of_N()` zurückgelieferten "best-of" Statistiken werden gesammelt und in der Statistik zusammengeführt.

Je CPU-Zahl wird eine Tabelle erstellt, die Spalten sind die Statistiken der einzelnen Testfälle, die Zeilen die einzeln erfassten Zeiten.
